summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorSami Kerola2014-04-12 01:59:31 +0200
committerSami Kerola2014-04-26 20:04:57 +0200
commit2556c387aa073c0165bbfe323bf6a42141430518 (patch)
treebd6ed435a9b12dab736c3d78e5e521b70cadda7e
parenttests: check kill print pid option (diff)
downloadkernel-qcow2-util-linux-2556c387aa073c0165bbfe323bf6a42141430518.tar.gz
kernel-qcow2-util-linux-2556c387aa073c0165bbfe323bf6a42141430518.tar.xz
kernel-qcow2-util-linux-2556c387aa073c0165bbfe323bf6a42141430518.zip
tests: check kill all user processes
CC: Bernhard Voelker <mail@bernhard-voelker.de> Signed-off-by: Sami Kerola <kerolasa@iki.fi>
-rw-r--r--tests/commands.sh2
-rw-r--r--tests/expected/kill/all_processes5
-rwxr-xr-xtests/ts/kill/all_processes66
3 files changed, 72 insertions, 1 deletions
diff --git a/tests/commands.sh b/tests/commands.sh
index 33bb1ab94..4b5a7d96d 100644
--- a/tests/commands.sh
+++ b/tests/commands.sh
@@ -1,5 +1,5 @@
# Misc settings
-TS_TESTUSER=${TS_TESTUSER:-"test"}
+TS_TESTUSER=${TS_TESTUSER:-"nobody"}
# helpers
TS_HELPER_BYTESWAP="$top_builddir/test_byteswap"
diff --git a/tests/expected/kill/all_processes b/tests/expected/kill/all_processes
new file mode 100644
index 000000000..c428372cf
--- /dev/null
+++ b/tests/expected/kill/all_processes
@@ -0,0 +1,5 @@
+test 1
+kill: cannot find process "test_sigreceive".
+test 2
+test 3
+kill: cannot find process "test_sigreceive".
diff --git a/tests/ts/kill/all_processes b/tests/ts/kill/all_processes
new file mode 100755
index 000000000..8d6238152
--- /dev/null
+++ b/tests/ts/kill/all_processes
@@ -0,0 +1,66 @@
+#!/bin/bash
+
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="all_processes"
+
+. "$TS_TOPDIR/functions.sh"
+ts_init "$*"
+
+ts_skip_nonroot
+
+ts_check_test_command "$TS_CMD_KILL"
+ts_check_test_command "$TS_HELPER_SIGRECEIVE"
+
+HELPER_SYMLINK="$TS_CWD/$(mktemp -u XXXXXXXXXXXXXXX)"
+ln -s "$TS_HELPER_SIGRECEIVE" "$HELPER_SYMLINK"
+trap "rm -f $HELPER_SYMLINK" 0
+
+"$HELPER_SYMLINK" -s "$TS_TESTUSER" >> "$TS_OUTPUT" 2>&1 &
+TEST_PID=$!
+
+# test_sigreceive needs time to start up
+for i in 0.01 0.1 1 1 1 1; do
+ awk 'BEGIN { retval=1 }
+ $1 ~ /^SigCgt/ {
+ lbyte = strtonum("0x" substr($2, 16, 16))
+ if (and(lbyte, 1)) {
+ retval=0
+ }
+ } END {
+ exit retval
+ }' /proc/$TEST_PID/status &&
+ up=1 &&
+ break
+ sleep $i
+done
+echo "test 1" >> "$TS_OUTPUT"
+"$TS_CMD_KILL" ${HELPER_SYMLINK##*/} >> "$TS_OUTPUT" 2>&1
+if [ $? -ne 1 ]; then
+ echo "kill did not return 1" >> "$TS_OUTPUT"
+fi
+echo "test 2" >> "$TS_OUTPUT"
+"$TS_CMD_KILL" -a ${HELPER_SYMLINK##*/} >> "$TS_OUTPUT" 2>&1
+if [ $? -ne 0 ]; then
+ echo "kill did not return 0" >> "$TS_OUTPUT"
+fi
+echo "test 3" >> "$TS_OUTPUT"
+"$TS_CMD_KILL" -a -p ${HELPER_SYMLINK##*/} >> "$TS_OUTPUT" 2>&1
+if [ $? -ne 1 ]; then
+ echo "kill -a -p did not return 1" >> "$TS_OUTPUT"
+fi
+
+sed -i "s/${HELPER_SYMLINK##*/}/${TS_HELPER_SIGRECEIVE##*/}/" "$TS_OUTPUT"
+
+ts_finalize